searchNodes=[{"doc":"Reads and parses the application's Mix config.UsageIn order to get values, you may first add dynamic configuration to config/prod.exs:config :confix, base_app: :my_project # defaults to Mix app, so it&#39;s usually not needed config :my_project, feature_x_enabled: {:system, &quot;FEATURE_X_ENABLED&quot;, type: :boolean, default: false} config :my_project, MyProject.Web.Endpoint, pubsub: [url: {:system, &quot;REDIS_URL&quot;}]You may get these values in your own code:iex&gt; Confix.get(:feature_x_enabled) false iex&gt; System.put_env(&quot;FEATURE_X_ENABLED&quot;, &quot;1&quot;) :ok iex&gt; Confix.get(:feature_x_enabled) true iex&gt; System.put_env(&quot;REDIS_URL&quot;, &quot;redis://localhost:6379&quot;) :ok iex&gt; Confix.get_in(MyProject.Web.Endpoint, [:pubsub, :url]) &quot;redis://localhost:6379&quot;You may also want to parse arbitrary configuration that doesn't come from Mix:iex&gt; System.put_env(&quot;ADAPTER_URL&quot;, &quot;http://example.com&quot;) :ok iex&gt; Confix.parse({:system, &quot;ADAPTER_URL&quot;}) &quot;http://example.com&quot; iex&gt; Confix.deep_parse(adapter: [url: {:system, &quot;ADAPTER_URL&quot;}]) [adapter: [url: &quot;http://example.com&quot;]]Sometimes however the place where you'd like system tuples to be read lies outside your own code and in 3rd party applications that don't natively support them. That could be (and actually is) the case of MyProject.Web.Endpoint on examples above - the Redis adapter for Phoenix PubSub doesn't properly parse the system tuples. In such cases, 3rd party config can be easily patched with Confix.Application.Usage in modulesYou may also use Confix in your own modules in order to have quick means for getting config associated with that particular module:defmodule MyProject.MyHTTPClient do use Confix def call do url = config!(:url) # ... end endSyntaxSystem tuples may have the following syntax:{:system, &quot;ENV_VAR&quot;} {:system, &quot;ENV_VAR&quot;, default: &quot;xyz&quot;} {:system, &quot;ENV_VAR&quot;, type: :integer} {:system, &quot;ENV_VAR&quot;, type: :boolean, default: true} {:system, [&quot;ENV_VAR_1&quot;, &quot;ENV_VAR_2&quot;]}","ref":"Confix.html","title":"Confix","type":"module"},{"doc":"Gets the parsed config value for specified key.Options:app - specifies the app to get config for, default: :base_app config or Mix app name:deep - deep parses the retrieved value, default: falseExamplesiex&gt; Confix.get(:feature_x_enabled) false iex&gt; System.put_env(&quot;FEATURE_X_ENABLED&quot;, &quot;1&quot;) :ok iex&gt; Confix.get(:feature_x_enabled) true","ref":"Confix.html#get/2","title":"Confix.get/2","type":"function"},{"doc":"Same as get/2 but raises Confix.KeyError if config is missing.","ref":"Confix.html#get!/2","title":"Confix.get!/2","type":"function"},{"doc":"Gets the parsed config value for specified list of nested keys.Options:app - specifies the app to get config for, default: :base_app config or Mix app name:deep - deep parses the retrieved value, default: falseExamplesiex&gt; System.put_env(&quot;REDIS_URL&quot;, &quot;redis://localhost:6379&quot;) :ok iex&gt; Confix.get_in(MyProject.Web.Endpoint, [:pubsub, :url]) &quot;redis://localhost:6379&quot;","ref":"Confix.html#get_in/2","title":"Confix.get_in/2","type":"function"},{"doc":"Same as get_in/2 but raises Confix.KeyError if config is missing.","ref":"Confix.html#get_in!/2","title":"Confix.get_in!/2","type":"function"},{"doc":"Parses a config value which may or may not be a system tuple.Examplesiex&gt; System.put_env(&quot;ADAPTER_URL&quot;, &quot;http://example.com&quot;) :ok iex&gt; Confix.parse({:system, &quot;ADAPTER_URL&quot;}) &quot;http://example.com&quot;","ref":"Confix.html#parse/1","title":"Confix.parse/1","type":"function"},{"doc":"Parses a nested config structure which may or may not contain system tuples.Examplesiex&gt; System.put_env(&quot;ADAPTER_URL&quot;, &quot;http://example.com&quot;) :ok iex&gt; Confix.deep_parse(adapter: [url: {:system, &quot;ADAPTER_URL&quot;}]) [adapter: [url: &quot;http://example.com&quot;]]","ref":"Confix.html#parse_deep/1","title":"Confix.parse_deep/1","type":"function"},{"doc":"Patches the specified application's Mix configs upon project startup.UsageSet the following in your config/prod.exs:config :confix, :patch, my_project: MyProject.Web.Endpoint, # patches specific key in specific application project_2: [], # patches all keys in specific application project_3: [:adapter, :url] # patches only given nested key in specific applicationThat's it. The configuration for specific apps and keys will be parsed using Confix.parse_deep/1 and persisted in the Mix config. So all system tuples will be replaced with actual environment variable values, with optional casting and defaults as specified in the Confix module docs.","ref":"Confix.Application.html","title":"Confix.Application","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Confix.Application.html#child_spec/1","title":"Confix.Application.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Confix.Application.html#init/1","title":"Confix.Application.init/1","type":"function"},{"doc":"Raised when required configuration is missing.","ref":"Confix.KeyError.html","title":"Confix.KeyError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Confix.KeyError.html#message/1","title":"Confix.KeyError.message/1","type":"function"},{"doc":"ConfixRead, parse and patch Elixir application's configurationFeatures:Get Mix config for your application in the most compact wayParse {:system, &quot;ENV_VAR&quot;} tuples automatically for runtime config capabilitiesCast system tuples to specific type and provide defaultsLoad config via system tuples from multiple env vars, taking first present onePatch external library configs with all the above capabilities","ref":"readme.html","title":"Confix","type":"extras"},{"doc":"Add confix as a dependency to your project in mix.exs:defp deps do [{:confix, &quot;~&gt; 0.4&quot;}] endThen run mix deps.get to fetch it.","ref":"readme.html#getting-started","title":"Confix - Getting Started","type":"extras"},{"doc":"Visit documentation on HexDocs for a complete API reference.","ref":"readme.html#documentation","title":"Confix - Documentation","type":"extras"}]